//************************************************************************
//     dferrors.h
//     2009 © DigiFi Limited
//
//     This is the headerfile defines all of the errors that can be
//     outputted from this library (Not really used yet)
//
//************************************************************************


#ifndef DFERRORS_HEADER
#define DFERRORS_HEADER

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>

// connection issues
#define DFCLIENT_ECONNECTFAILED			10001
#define DFCLIENT_ETIMEOUT				10002
#define DFCLIENT_ENOMEM					10003

#define DEBUG

#ifdef DEBUG
#define DFDEBUG(...) { FILE *fd = fopen("/tmp/df.log","at"); fprintf(fd, "%s:%d %s() ", __FILE__, __LINE__, __func__); fprintf(fd, __VA_ARGS__); fprintf(fd, ""); fclose(fd); }
//#define STDEBUG(...) { FILE *fd = stdout; fprintf(fd, "%s:%d %s() ", __FILE__, __LINE__, __func__); fprintf(fd, __VA_ARGS__); fprintf(fd, "\n"); }
#define DFERROR(...) { FILE *fd = fopen("/tmp/df.log","at"); fprintf(fd, "%s:%d %s() ERROR ", __FILE__, __LINE__, __func__); fprintf(fd, __VA_ARGS__); fprintf(fd, ""); fclose(fd); }
#else
#define DFDEBUG(...)
#define DFERROR(...)
#endif

void dferrors_register_errorcallback(void (*callback)(int, char*));

void dferrors_register_debugcallback(void (*callback)(char*));

char* dferrors_translateerror(int error_num);

void dferrors_printerror(int num, char* message, ...);
void dferrors_printdebug(char* message, ...);

#ifdef __cplusplus
}
#endif

#endif